#### POSIX Threads for Windows – REFERENCE - Pthreads-w32

Reference Index

Table of Contents

## Name

pthread_rwlockattr_destroy, pthread_rwlockattr_init - destroy and initialize the read-write lock attributes object

## Synopsis

#include <pthread.h>

int pthread_rwlockattr_destroy(pthread_rwlockattr_t *attr);
int pthread_rwlockattr_init(pthread_rwlockattr_t *attr);

## Description

The pthread_rwlockattr_destroy function shall destroy a read-write lock attributes object. A destroyed attr attributes object can be reinitialized using pthread_rwlockattr_init ; the results of otherwise referencing the object after it has been destroyed are undefined. An implementation may cause pthread_rwlockattr_destroy to set the object referenced by attr to an invalid value.

The pthread_rwlockattr_init function shall initialize a read-write lock attributes object attr with the default value for all of the attributes defined by the implementation.

Results are undefined if pthread_rwlockattr_init is called specifying an already initialized attr attributes object.

After a read-write lock attributes object has been used to initialize one or more read-write locks, any function affecting the attributes object (including destruction) shall not affect any previously initialized read-write locks.

Pthreads-w32 defines _POSIX_READER_WRITER_LOCKS in pthread.h as 200112L to indicate that the reader/writer routines are implemented and may be used.

## Return Value

If successful, the pthread_rwlockattr_destroy and pthread_rwlockattr_init functions shall return zero; otherwise, an error number shall be returned to indicate the error.

## Errors

The pthread_rwlockattr_destroy function may fail if:

EINVAL
  The value specified by attr is invalid.

The pthread_rwlockattr_init function shall fail if:

ENOMEM
  Insufficient memory exists to initialize the read-write lock attributes object.

These functions shall not return an error code of [EINTR].

The following sections are informative.

## Examples

None.

## Application Usage

None.

## Rationale

None.

## Future Directions

None.

## See Also

pthread_rwlock_destroy(3) , pthread_rwlockattr_getpshared(3) , pthread_rwlockattr_setpshared(3) , the Base Definitions volume of IEEE Std 1003.1-2001, <pthread.h>

## Copyright

Portions of this text are reprinted and reproduced in electronic form from IEEE Std 1003.1, 2003 Edition, Standard for Information Technology -- Portable Operating System Interface (POSIX), The Open Group Base Specifications Issue 6, Copyright (C) 2001-2003 by the Institute of Electrical and Electronics Engineers, Inc and The Open Group. In the event of any discrepancy between this version and the original IEEE and The Open Group Standard, the original IEEE and The Open Group Standard is the referee document. The original Standard can be obtained online at http://www.opengroup.org/unix/online.html .

Modified by Ross Johnson for use with Pthreads-w32.

Table of Contents

- Name

- Synopsis

- Description

- Return Value

- Errors

- Examples

- Application Usage

- Rationale

- Future Directions

- See Also

- Copyright